<?php defined('SYSPATH') or die('No direct script access.');
class Welcome_Controller extends Website_Controller 
{	
	const ALLOW_PRODUCTION = FALSE;
	public $template = 'template/template';
	public function __construct()
	{
		parent::__construct();

		$session = Session::instance();
		if($session->get('userid')){
			url::redirect($this->docroot."profile");
		}
	
		
		$this->get_city = $this->model->get_city();
		$this->model = new Menu_Model();
		$this->profile = new Profile_Model();
		$this->users = new Users_Model();

	}
	public function index()
	{
         //pagination
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='public_profile')
		$page_no = 1;
		//offset value from 1 to 10
		$offset=10*($page_no-1);
		 
		 $this->answers = new Answers_Model();
		 		 
		 $this->template->my_answers = $this->answers->get_question($offset,$page_no, 10);
                 $this->total =  $this->answers->get_recent_count();
		        $this->template->pagination = new Pagination(array
		        (
		        'base_url'       => 'welcome',
		        'uri_segment'    =>'index',
		        'items_per_page' => 10,
		        'total_items'    => $this->total,
		        'style'         => 'classic' )
		        );
	 $this->template->title = "PHP open source social media application"; 
	 $this->template->content = new View('register');
	 $this->template->title = "PHP open source social media application";
	}
	
	public function register()
	{ 	
			if($this->userid)
			{
				url::redirect($this->docroot."profile");
			}

			if($_POST)
			{
				$post = new Validation($_POST);
				$post = Validation::factory($_POST)
						->add_rules('name', 'required', 'length[4,32]', 'chars[a-zA-Z0-9_ .]')
						->add_rules('email', 'required', 'length[4,127]', 'valid::email', array($this, 'email_available') )
						->add_rules('password', 'required', 'length[4,32]')
						->add_rules('password2','required', 'matches[password]')
						->add_rules('dob', 'required')
						->add_rules('type', 'required')
						->add_rules('city', 'required')
						->add_rules('gender', 'required')
						->add_rules('terms', 'required');
						
					$user_post = $this->input->post();
				if($post->validate()){
	
					$status = $this->users->adduser(arr::to_object($user_post));
					if($status == 1){
						url::redirect($this->docroot."profile/updateprofile");
					}
					else{
						url::redirect($this->docroot);
					}
				}
				else{
					$this->reg_error = $this->_error($post->errors());
					$this->user_post = $user_post;
				}
			}
			/* else{
				if($key == md5("ndot".$id )){
					$this->email = $this->model->get_email($id);
					if($this->email){
						$_SESSION["reg_email"] = $this->email;
						$this->template->content = new View('register');
						$this->template->title = Kohana::config("application.strings.hometitle");
					}
				}
				else{
					url::redirect($this->docroot);
				}
			} */
			$this->template->content = new View('register');
			$this->template->title = "Developers Network,Developers can share their codes,job oppurtunities,questions and answers";
		
	}
	
	//email validation
	public function email_available($email)
	{
	        
		$exist = $this->users->exist_email($email);
		if($exist){
			Nauth::setMessage(-1,"You already in blinkbee Network");
			url::redirect($this->docroot);
		}
		return ! $exist;
	}
	
        //error function
	private function _error($err_arr = "")
	{
		foreach($err_arr as $key => $value)
		{
			switch ($value) {
				case 'required':
					 $my_error[$key] = "* Required";
					break;
				case 'length':
					if($key == "email"){
						$my_error[$key] = "* Invalid Email";
					}else{
						$my_error[$key] = $key ." should be 4-32 chars";
					}
					break;	
				case 'email':
					 $my_error[$key] = "* Invalid Email";
					break;	
				case 'email_available':
					 $my_error[$key] = "* Email Already use";
					break;	
				case 'matches':
					 $my_error[$key] = "* Password does not match";
					break;
				case 'username_available':
					 $my_error[$key] = "* Username Already use";
					break;
				case 'chars':
					 $my_error[$key] = "* Invalied " .$key;
					break;
			}
		}
        	return $my_error;		
	}
	
	//public profile
	public function public_profile($name = "" ,$id = "")
	{
		 
		 $view=$this->input->get("view");
		 
		 $this->template->content = new View('public_profile');
		 $this->template->title = ucfirst($name)."'s Profile";
		 $this->public_profile_data = $this->model->get_public_profile($name, $id);
		 if(count($this->public_profile_data) == 0){
		 	url::redirect($this->docroot);
		 }
		 //pagination
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='public_profile')
		$page_no = 1;
		//offset value from 1 to 10
		$offset=10*($page_no-1);
		 
		 $this->total_codes =  $this->model->get_count_mycodes($id);
		 $this->total_answers =  $this->model->get_count_myanswers($id);
		 
		 if($view=='codes')
		 {
		 $this->template->get_codes = $this->model->get_mycodes($id,$offset,$page_no, 10);
		 $this->total =  $this->model->get_count_mycodes($id);	
		        $this->template->pagination = new Pagination(array
		        (
		        'base_url'       => 'welcome',
		        'uri_segment'    =>'public_profile',
		        'items_per_page' => 10,
		        'total_items'    => $this->total,
		        'style'         => 'classic' )
		        );
		 }
		 else
		 {    
		 $this->template->my_answers = $this->model->get_myanswers($id,$offset,$page_no,10);
                 $this->total =  $this->model->get_count_myanswers($id);	
		        $this->template->pagination = new Pagination(array
		        (
		        'base_url'       => 'welcome',
		        'uri_segment'    =>'public_profile',
		        'items_per_page' => 10,
		        'total_items'    => $this->total,
		        'style'         => 'classic' )
		        );
		 }
		 
		 
		 $this->my_works = $this->model->get_myworks($id);
		 $this->my_friends = count($this->profile->my_friends($id,1));
 
	}

	
	public function __call($method, $arguments)
	{
		$this->auto_render = TRUE;
		echo 'This text is generated by __call. If you expected the index page, you need to use: welcome/index/'.substr(Router::$current_uri, 8);
	}
}
