<?php defined('SYSPATH') or die('No direct script access.');
class Groups_Controller extends Website_Controller  {
	const ALLOW_PRODUCTION = FALSE;
	public $template = 'template/template';
	public function __construct()
	{
		parent::__construct();
		$this->model = new Groups_Model();
		$this->module = "groups";
		Nauth::module_login($this->module);
		if(!in_array("groups", $this->session->get("enable_module"))) {
			url::redirect($this->docroot."profile");
			die();
		}
		$mes = Kohana::config('users_config.session_message');
		$this->group_create = $mes["group_create"];
		$this->delete_group = $mes["delete_group"];
		$this->update_group = $mes["update_change"];
		$this->add_comment = $mes["add_comment"];
		$this->delete_comment = $mes["delete_comment"];
		$this->delete_forum = $mes["delete_forum"];
		$this->upload_photo = $mes["upload_photo"];
		$this->update_change = $mes["upload_photo"];
		$this->delete_photo = $mes["delete_photo"];
		$this->group_unjoin = $mes["group_unjoin"];
		$this->member_added = $mes["member_added"];
		$this->member_rejected = $mes["member_rejected"];
		$this->invitation_sent = $mes["invitation_sent"];
		$this->not_authro = $mes["noacces"];
		$this->page_notfound = $mes["notfound"];
		$this->delete_wall = $mes["delete_wall"];
		$this->delete_group_member = $mes["delete_group_member"];
	}

	public function test()
	{
		$kr = '/inbox/compose';
		$req = Request::instance($kr)->execute();
		echo $req->response;exit;
	}
   	//Home page of groups
	public function index() 
	{   
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='index')
		$page_no = 1;
		$offset=15*($page_no-1);

		$this->get_groups_list=$this->model->get_groups_list($offset,15);

		$this->total=$this->model->get_groups_count();
	
		$this->template->pagination = new Pagination(array
		 (
		 'base_url'       => 'groups',
		 'uri_segment'    =>'index',
		 'items_per_page' => 15,
		 'total_items'    => $this->total,
		 'style'         => 'classic' )
		 );

		//template code
		$this->template->title="Recent Groups";
		$this->left=new View("groups_leftmenu");
		$this->right=new View("groups_content");
		$this->title_content = "Recent Groups";
		$this->template->content=new View("/template/template2");
	}

	//popular groups
	public function popular() 
	{   
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='index')
		$page_no = 1;
		$offset=15*($page_no-1);

		$this->get_groups_list=$this->model->get_popular_groups_list($offset,15);

		$this->total=$this->model->get_groups_count();
	
		$this->template->pagination = new Pagination(array
		 (
		 'base_url'       => 'groups',
		 'uri_segment'    =>'index',
		 'items_per_page' => 15,
		 'total_items'    => $this->total,
		 'style'         => 'classic' )
		 );

		//template code
		$this->template->title="Popular Groups";
		$this->left=new View("groups_leftmenu");
		$this->right=new View("groups_content");
		$this->title_content = "Popular Groups";
		$this->template->content=new View("/template/template2");
	}

	//popular groups
	public function category() 
	{   
		$cid=$this->input->get("cid");
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='index')
		$page_no = 1;
		$offset=15*($page_no-1);

		$this->get_groups_list = $this->model->get_groups_by_category($cid,$offset,15);

		$this->total=$this->model->get_groups_category_count($cid);
	        
	        if($this->total>0)
	        {
	                $curent_category_name = $this->get_groups_list["mysql_fetch_array"]->group_category_name;
	        }else {
	        $curent_category_name =" Result";
	        }
	        
		$this->template->pagination = new Pagination(array
		(
		 'base_url'       => 'groups',
		 'uri_segment'    =>'index',
		 'items_per_page' => 15,
		 'total_items'    => $this->total,
		 'style'         => 'classic' )
		);

		//template code
		$this->template->title="Search Groups";
		$this->left=new View("groups_leftmenu");
		$this->right=new View("groups_content");
		$this->title_content = "Category - ". $curent_category_name;
		$this->template->content=new View("/template/template2");
	}

	//my groups
	public function mygroups() 
	{   
		Nauth::is_login();
        $this->get_groups_category=$this->model->get_category();
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='index')
		$page_no = 1;
		$offset=15*($page_no-1);

		$this->get_groups_list=$this->model->get_mygroups($this->userid,$offset,15);

		$this->total=$this->model->count_mygroups($this->userid);
	
		$this->template->pagination = new Pagination(array
		(
		 'base_url'       => 'groups',
		 'uri_segment'    =>'index',
		 'items_per_page' => 15,
		 'total_items'    => $this->total,
		 'style'         => 'classic' )
		);

		//template code
		$this->template->title="My Groups";
		$this->left = new View("groups_leftmenu");
		$this->center = new View("mygroups");
		$this->right = new View("groups_category");
		$this->title_content = "My Groups";
		$this->template->content=new View("/template/template3");
	}
	//delete group
	public function delete_group()
	{
		Nauth::is_login();
		$gid=$this->input->get("gid");
		$this->delete = $this->model->delete_group($gid);
		if($this->delete)
		{
		Nauth::setMessage(1,$this->delete_group);
		url::redirect($this->docroot.'groups/mygroups/');
		}
		else
		{
		 Nauth::setMessage(-1,$this->page_notfound);
		 url::redirect($this->docroot.'groups/'); 
		}

	}
	//edit the group
	public function edit()
	{
		Nauth::is_login();
		$gid=$this->input->get("gid");
		$this->edit_group=$this->model->edit_group($gid);
		//get the inputs
		if($_POST)
		{
			$title = $this->input->post('title');
			$gid=$this->input->post("gid");
			$group_image=$_FILES['group_image']['name'];
			$location = $this->input->post('location');
			$country = $this->input->post('country');
			$category = $this->input->post('category');					
			$access = $this->input->post('access');	
			$desc = $this->input->post('desc');
			$website = $this->input->post('website');
			$company = $this->input->post('company');
			$member='';
			$this->update_group_info = $this->model->update_group($title,$group_image,$country,$category,$access,$website,$desc,$company,$this->userid,$member,$location,$gid);
			Nauth::setMessage(1,$this->update_group);
			
			url::redirect($this->docroot.'groups/mygroups/');
		}
		//template code

		$this->template->title="Edit Groups";
		$this->get_city = $this->model->get_city();
		$this->template->get_category = $this->model->get_category();
		$this->left=new View("groups_leftmenu");
		$this->right=new View("edit_group");
		$this->title_content = "Edit Group Information";
		$this->template->content=new View("/template/template2");	

	}
	
	//getting groups information to left side
	public function groups_left()
	{
	
		
		$this->gid=$this->input->get("gid");
		$this->group_members_id=$this->model->check_group_members_id($this->gid);  //getting the group informations

		$this->group_info=$this->model->group_info($this->gid);  //getting the group informations

		$this->check_current_user_in_group = $this->model->check_current_user_in_group($this->gid,$this->userid);  //getting the group informations
                $this->is_group_member = count($this->check_current_user_in_group);
		
		$this->group_requests_count=$this->model->get_group_requests($this->gid);  //getting the group requests for admin privilage group

	 }
	 
    	//display the group information
	public function view()
	{  
		$this->groups_left();
		
		if(count($this->group_info) == 0){
			Nauth::setMessage(-1,$this->page_notfound);
			url::redirect($this->docroot.'groups');
		}
		//rating start
		        if($this->input->get('url'))
				{
					$this->ratings = new Ratings_Model();
                                        $url = $this->input->get('url');
		                                $type = $this->input->get('type');
		                                $type_id = $this->input->get('type_id');
		                                $rating = $this->input->get('rating');
		                                $ipadd = $_SERVER['REMOTE_ADDR']; 
										
		                                if($url != '' && $type != '' && $type_id != '')
		                                {
		                                        
		                                        $this->insert_rate = $this->ratings->insert_rating($url,$type,$type_id,$ipadd,$rating);
		                                        if($this->insert_rate == 1)
		                                        {
		                                                $this->session->set('Msg','Your Rating has been Successfully Added');
		                                                url::redirect($url);
		                                        }
		                                        elseif($this->insert_rate == -1)
		                                        {
		                                                $this->session->set('Emsg','Your Rating Already Exist.');
		                                                url::redirect($url);
		                                        }
		                                }
		                                else
		                                {
		                                        $this->session->set('Emsg','Not allowed to Rate. Please try Later');
		                                        url::redirect($url);
		                                }				
		          }
		          //rating end
		
		$current_action = $this->input->get("action");
		
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='wall')
		$page_no = 1;
		$offset=15*($page_no-1);
		
		if($current_action == "wall"){
		        if($this->is_group_member == 0){
		                $this->notice = "You must join in this Group to Post the Wall";
		        }
		        $this->group_wall = $this->model->get_wall($this->gid,$offset,15);
		        $this->total_wall = $this->model->count_wall($this->gid);
		        $this->template->wall_pagination = new Pagination(array
		        (
		         'base_url'       => 'groups',
		         'uri_segment'    => 'view',
		         'items_per_page' => 15,
		         'total_items'    =>$this->total_wall,
		         'style'         => 'classic' )
		         ); 
                }

			if($current_action == "discussion")
			{
			
		        if($this->is_group_member == 0){
		             $this->notice = "You must join in this Group to Start Discussion";
		        }
		        
		   
		        $this->discuss_category = $this->model->get_discuss_category();
		        $this->cout_discussion = $this->model->count_forums($this->gid);
		        $this->get_discussion = $this->model->get_forums($this->gid,$offset,15);
		        $this->template->discussion_pagination = new Pagination(array
		         (					
		         'base_url'       => 'groups', 
		         'uri_segment'    => 'view', 
		         'items_per_page' => 15,
		         'total_items'    => $this->cout_discussion,
		         'style'         => 'classic' ));
            }
                

                if($current_action == "photos")
                {
		        	if($this->is_group_member == 0){
		                $this->notice = "You must join in this Group to Add Photos";
		        	}
                                        if($this->input->get("subaction") == "edit")
                                        {
                                                $gid = $this->input->get("gid");
                                                $photo_id = $this->input->get("photo_id");
                                                $this->single_photo_info = $this->model->single_photo_info($photo_id,$gid);
                                        }
					$this->template->show_photo=$this->model->show_photo($this->gid,$offset,15);
					$this->total=$this->model->get_count_show($this->gid);
					$this->template->photos_pagination = new Pagination(array(
						'base_url'       => 'groups',
						'uri_segment'    =>'view',
						'items_per_page' => 15,
						'total_items'    => $this->total,
						'style'         => 'digg' 
						));		
                }
                
                if($current_action == "info")
                {
                        $this->recent_group_discussion = $this->model->get_forums($this->gid,0,5);
                        $this->recent_group_photo = $this->model->show_photo($this->gid,0,6);
                        $this->total=$this->model->get_count_show($this->gid);
			$this->template->photos_pagination = new Pagination(array(
				'base_url'       => 'groups',
				'uri_segment'    =>'view',
				'items_per_page' => 15,
				'total_items'    => $this->total,
				'style'         => 'digg' 
				));	
						
                        $this->recent_group_members = $this->model->get_group_members($this->gid,0,5);
                        
                }
                
		//template code
		$this->template->title="Group - ".htmlspecialchars_decode($this->group_info["mysql_fetch_array"]->group_name);
		$this->left = new View("group_left_info");
		$this->right = new View("group_view");
		$this->title_content = htmlspecialchars_decode($this->group_info["mysql_fetch_array"]->group_name);
		$this->template->content=new View("/template/template2");

	}
	
	//display the group information
	public function search_discussion()
	{  
		     $this->groups_left();
		
		     if($this->is_group_member == 0)
		     {
		             $this->notice = "You must join in this Group to Start Discussion";
		     }
		        $page_no=$this->uri->last_segment();
		        if($page_no==0 || $page_no=='wall')
		        $page_no = 1;
		        $offset=15*($page_no-1);
		
		        $key = $this->input->get("discussion_search_value");  
		       
		        $this->discuss_category = $this->model->get_discuss_category();
		        $this->cout_discussion = $this->model->count_search_forums($key,$this->gid);
		        $this->get_discussion = $this->model->get_search_forums($key,$this->gid,$offset,15);
		        $this->template->discussion_pagination = new Pagination(array
		         (					
		         'base_url'       => 'groups', 
		         'uri_segment'    => 'view', 
		         'items_per_page' => 15,
		         'total_items'    => $this->cout_discussion,
		         'style'         => 'classic' ));
           

               
		//template code
		$this->template->title="Search Group Discussion";
		$this->left = new View("group_left_info");
		$this->right = new View("search_forum_result");
		$this->title_content = "Search Group Discussion";
		$this->template->content=new View("/template/template2");

	}
	
	//delete group wall
	
	public function delete_wall()
	{
		Nauth::is_login();
		$wall_id = $this->input->get("id");
		$gid = $this->input->get("gid");
		$this->model->delete_wall($wall_id,$this->userid);
		common::delete_update("",7,$wall_id);
		Nauth::setMessage(1,$this->delete_wall); //set session message using library
		url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=wall');
	}
		
	//get the group requested members
	public function requests()
	{
		Nauth::is_login();
		$this->groups_left();
		$this->get_groups_category=$this->model->get_category();
		//pagination start
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='members')
		$page_no = 1;
		$offset=15*($page_no-1);
		
		$this->group_requested_members=$this->model->get_group_requests_members($this->gid,$offset,15);
		
		$this->template->pagination = new Pagination(array
		(
		 'base_url'       => 'groups',
		 'uri_segment'    => 'requests',
		 'items_per_page' => 15,
		 'total_items'    => $this->group_requests_count,
		 'style'         => 'classic' )
		 ); 
		 
		//template code
		$this->template->title="Group - ".htmlspecialchars_decode($this->group_info["mysql_fetch_array"]->group_name);
		$this->left=new View("group_left_info");
		$this->center=new View("group_request");
		$this->right=new View("groups_category");
		$this->title_content = htmlspecialchars_decode($this->group_info["mysql_fetch_array"]->group_name);
		$this->template->content=new View("/template/template3");
	}
	
	//get the group  members
	public function members()
	{
		$this->groups_left();
		$this->get_groups_category=$this->model->get_category();
		
		//pagination start
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='members')
		$page_no = 1;
		$offset=15*($page_no-1);
		
		$this->group_members=$this->model->get_group_members($this->gid,$offset,15);  //getting the group informations
		
		$this->template->pagination = new Pagination(array
		(
		 'base_url'       => 'groups',
		 'uri_segment'    => 'members',
		 'items_per_page' => 15,
		 'total_items'    => count($this->group_members_id),
		 'style'         => 'classic' )
		 ); 
		 
		//template code
		$this->template->title="Group - ".htmlspecialchars_decode($this->group_info["mysql_fetch_array"]->group_name);
		$this->left=new View("group_left_info");
		$this->center=new View("group_members");
		$this->right=new View("groups_category");
		$this->title_content =htmlspecialchars_decode( $this->group_info["mysql_fetch_array"]->group_name);
		$this->template->content=new View("/template/template3");
	}
	
	//approve the requests
	public function approve()
	{
		Nauth::is_login();
		$gid=$this->input->get("gid");
		$uid=$this->input->get("uid");
		$this->model->approve_requests($gid,$uid);
		Nauth::setMessage(1,$this->member_added);
		url::redirect($this->docroot.'groups/requests/?gid='.$gid.'&type=1');
	}
	
	//approve the requests
	public function reject()
	{
		Nauth::is_login();
		$gid=$this->input->get("gid");
		$uid=$this->input->get("uid");
		$this->model->reject_requests($gid,$uid);
		Nauth::setMessage(1,$this->member_rejected);
		url::redirect($this->docroot.'groups/requests/?gid='.$gid.'&type=1');
	}
	//create the group
	public function add()
	{
		Nauth::is_login();
		if($_POST)
		{
			$title = html::specialchars($this->input->post('title'));
			$group_image=$_FILES['group_image']['name'];
			//$group_image = $this->input->post('group_image');
			$location = html::specialchars($this->input->post('location'));
			$country = $this->input->post('country');
			$category = html::specialchars($this->input->post('category'));					
			$access = html::specialchars($this->input->post('access'));	
			$desc = html::specialchars($this->input->post('desc'));
			$website = html::specialchars($this->input->post('website'));
			$company = html::specialchars($this->input->post('company'));
			$member='';
			$this->create_group = $this->model->create_group($title,$group_image,$country,$category,$access,$website,$desc,$company,$this->userid,$member,$location);
			
			url::redirect($this->docroot.'groups/');
		}
		
		//template code

		$this->template->title="Create New Group";
		//$this->template->get_country = $this->model->get_country();
		$this->get_city = $this->model->get_city();
		
		$this->template->get_category = $this->model->get_category();
		$this->left=new View("groups_leftmenu");
		$this->right=new View("create_group");
		$this->title_content = "Create New Group";
		$this->template->content=new View("/template/template2");	

	}
	
        //create the group
	public function advanced()
	{
		
		$this->template->title="Advanced Group Search";
		$this->template->get_category = $this->model->get_category();
		
		$key = html::specialchars($this->input->get("title"));
		$category = $this->input->get("category");
		
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='advanced')
		$page_no = 1;
		$offset=15*($page_no-1);
		
		$this->get_groups_list=$this->model->get_advanced_search_groups_list($key,$category,$offset,15);
		
		$this->total=$this->model->get_advanced_search_groups_count($key,$category);
		
		$this->template->pagination = new Pagination(array
		(
			'base_url'       => 'groups',
			'uri_segment'    =>'advanced',
			'items_per_page' => 15,
			'total_items'    => $this->total,
			'style'         => 'classic' )
		);
		$this->left=new View("groups_leftmenu");
		$this->right=new View("advanced");
		$this->title_content = "Advanced Group Search";
		$this->template->content=new View("/template/template2");	

	}


	public function post_wall()
	{
		Nauth::is_login();
		if($_POST)
		{
			$poster_id=$this->userid;
			$gid=$this->input->post("gid");
			$wall=$this->input->post("wall_message");
			$this->model->post_wall($poster_id,$gid,$wall);
			//$this->add_wall=$this->update->updates_insert($poster_id,$userid,7,'wall',$wall);
			url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=wall');
		}
	}

	//post the discussion
	public function post_discussion()
	{ 
		Nauth::is_login();
		if($_POST)
		{
			$gid=$this->input->post("gid"); 
			$disc_category=$this->input->post("disc_category");
			$title=html::specialchars($this->input->post("topic"));
			$description=html::specialchars($this->input->post("topic_desc"));
			$this->result=$this->model->create_forum($gid,$title,$description,$this->userid,$disc_category); 
			url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=discussion');
		}

	}
	
	//delete the discussion
	public function delete_discussion()
	{
		Nauth::is_login();
		$gid=$this->input->get("gid");
		$id=$this->input->get("id");
		$this->result=$this->model->delete_discussion($id,$this->userid);
		Nauth::setMessage(1,$this->delete_forum);
		url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=discussion');
	
	}
	//delete members
	public function delete_member()
	{
		Nauth::is_login();
		$gid=$this->input->get("gid");
		$id=$this->input->get("id");
		$this->result=$this->model->delete_member($gid,$id);
		Nauth::setMessage(1,$this->delete_group_member);
		url::redirect($this->docroot.'groups/members/?gid='.$gid.'&type=photos');
	
	}
         //delete forum
   	public function delete_reply()
   	{
	    Nauth::is_login();
	    $cid=$this->input->get('cid');
	    $fid=$this->input->get('fid');
	    $gid=$this->input->get('gid');
	    
	    $this->delete = $this->model->delete_comment($cid,$fid);
	    if($this->delete)
	    {
	            Nauth::setMessage(1,$this->delete_comment);
	            url::redirect($this->docroot.'groups/discussion/?id='.$fid.'&gid='.$gid.'');
	    }
	    
	}
	
	public function delete_comment()
   	{
		Nauth::is_login();
	    $cid = $this->input->get('cid');
	    $type_id = $this->input->get('type_id');
	    $url = $this->input->get('url');
            common::delete_comment("photos_comments",$type_id,$cid,"groups");
            url::redirect(''.$url.'');
	    
	}
	
	//display the group information
	public function discussion()
	{  
		//get the groups category
		$this->get_groups_category=$this->model->get_category();
		$this->groups_left();

		$this->gid=$this->input->get("gid");
		$this->group_info=$this->model->group_info($this->gid);
		
		$topic_id=$this->input->get("id");
		$this->get_discussion_information=$this->model->get_discussion_information($topic_id);

		//pagenation
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='discussion')
		$page_no = 1;
			
		//offset value from 3 to 6 
		$offset=10*($page_no-1); 
		$this->total=$this->model->count_discussion($topic_id);
		$this->get_comment=$this->model->discuss($topic_id,$offset,10);
		$this->template->pagination = new Pagination(array
		 (
		 'base_url'       => 'groups',//our controller/function(page)
		 'uri_segment'    => 'discussion', //page(function)
		 'items_per_page' => 10,
		 'total_items'    => $this->total,
		 'style'         => 'classic' )
		 ); 

		//template code
		$this->template->title="Discussion - ".htmlspecialchars_decode($this->get_discussion_information["mysql_fetch_array"]->topic);
		$this->left=new View("group_left_info");
		$this->center=new View("group_discussion");
		$this->right=new View("groups_category");
		$this->title_content = $this->group_info["mysql_fetch_array"]->group_name;
		$this->template->content=new View("/template/template3");

	}
	//post the reply
	public function reply()
	{
		Nauth::is_login();
		$id=$this->input->post("id");
		$gid=$this->input->post("gid");
		$comments=html::specialchars($this->input->post("comments"));
		$this->result=$this->model->post_comment($id,$comments,$this->userid,$gid);
		$this->resul=$this->model->updatepost($id);
		$this->re=$this->model->updatedate($id);
		Nauth::setMessage(1,$this->add_comment);
		url::redirect($this->docroot.'groups/discussion/?id='.$id.'&gid='.$gid.'');
	}

	//upload photo
	public function photo()
	{    
		Nauth::is_login();
		if($_POST){
			$upload_title = $this->input->post('photo_title');
			$upload_description = $this->input->post('photo_description');
			$photo_name = $_FILES['upload_photo']['name'];
			$gid = $this->input->post("gid");
			$this->template->insert_photo = $this->model->insert_photo($this->userid,$gid,$upload_title,$upload_description,$photo_name);
			
			if($this->template->insert_photo == 0){
				Nauth::setMessage(-1,"Invalid Photo");
				url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=photos');
			}
			else{
				Nauth::setMessage(1,$this->upload_photo);
				url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=photos');
			}
			
		}
	}
	//Edit photo
	public function edit_photo()
	{
		Nauth::is_login();
		
		if($_POST)
		{
			$gid=$this->input->post('gid');
			$photo_id=$this->input->get('photo_id');
			$photo_title=$this->input->post('photo_name11');
			$description=$this->input->post('edit_description');
			
			$this->template->edit_photo=$this->model->edit_photo($photo_id,$photo_title,$description);
			Nauth::setMessage(1,$this->update_change);
			url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=photos');
		}

	}
	//Delete photo
	public function delete_photo()
	{
		Nauth::is_login();
		 $this->template->title = 'Delete-Photo';
		 $photo_id=$this->input->get('photo_id');
		 $gid=$this->input->get('gid');
	 	 $this->template->delete_photo=$this->model->delete_photo($photo_id);
		 Nauth::setMessage(1,$this->delete_photo);

		 url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=photos');
	
	}
	
	//View Full Photo
	public function zoom()
	{
		//get the groups category
		$this->get_groups_category=$this->model->get_category();
		$this->groups_left();
		$gid=$this->input->get("gid");
		
		$this->group_info=$this->model->group_info($gid);

		//error redirection 
		if(count($this->group_info) <=0 )
		{
			//$this->notice = $this->page_notfound;
			url::redirect($this->docroot."groups/");
		}

		$photo_id=$this->input->get('photo_id');
		
		if($_POST){
			Nauth::is_login(); 
			$type_id = $this->input->post('type_id');
			$redirect_url = $this->input->post('redirect_url');
			$desc= html::specialchars($this->input->post('desc'));
			common::post_comments("photos_comments",$type_id,$desc,"groups"); //post the comments using common function 		
			url::redirect(''.$redirect_url.'');
		}

		//pagination 
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='zoom')
		$page_no = 1;
		$offset=1*($page_no-1);
		$this->template->show_photo=$this->model->show_photo($gid,$offset,$page_no, 1);
	        $this->photoid = $this->template->show_photo["mysql_fetch_array"]->photo_id;

		$this->total=$this->model->get_count_show($gid);
		$this->template->pagination = new Pagination(array
		(
			'base_url'       => 'groups',
			'uri_segment'    =>'zoom',
			'items_per_page' => 1,
			'total_items'    => $this->total,
			'style'         => 'digg' )
		);

		$this->template->full_photo=$this->model->full_photo($this->photoid,$gid);
	

		// template code 
		$this->template->title = "Photos:".htmlspecialchars_decode($this->template->full_photo["mysql_fetch_array"]->photo_title);
		$this->left=new View("group_left_info");
		$this->right=new View("groups_full_photo");
		//$this->right=new View("groups_category");
		$this->title_content =htmlspecialchars_decode( $this->template->full_photo["mysql_fetch_array"]->photo_title);
		$this->template->content=new View("template/template2");
	}
	
	//join
	public function group_join()
	{
		Nauth::is_login();
		$gid=$this->input->get("gid");
		$type=$this->input->get("type");
		$this->model->group_join($gid,$this->userid,$type);
		url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=info');
	}
	//un join
	public function group_unjoin()
	{
		Nauth::is_login();
		$gid=$this->input->get("gid");
		$this->model->group_unjoin($gid,$this->userid);
		Nauth::setMessage(1,$this->group_unjoin);
		url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=info');
	}
	//invite people
	public function invite()
	{
		Nauth::is_login();
		$this->groups_left();
		$this->get_groups_category=$this->model->get_category();
		
		$this->get_friends_list=$this->model->get_friends_list($this->userid);
		//get the mail information
		if($_POST)
		{ 
				$invite_type=$this->input->post("invite_type");
				$gid=$this->input->post("gid");
				if($invite_type=="normal")
				{
					$to=$this->input->post("to");
					$subject=htmlspecialchars_decode($this->input->post("subject"));
					$message=$this->username." Inviting you to join in N.social features"."<br>";
					$message=$message.htmlspecialchars_decode($this->input->post("message"));
					$type="Invite friends";
					$email_ids=explode(',',$to);
					foreach($email_ids as $to)
					{
					
						if($to!='')
						{
							Nauth::send_mail($to,$this->from,$subject,$message,$type);
						}
					}
					Nauth::setMessage(1,$this->invitation_sent); //call the library function to set the session type
					url::redirect($this->docroot.'groups/view/?gid='.$gid.'&action=wall');
				}
			}
		//template code
		$this->template->title="Group - ".htmlspecialchars_decode($this->group_info["mysql_fetch_array"]->group_name);
		$this->left=new View("group_left_info");
		$this->center=new View("group_invite");
		$this->right=new View("groups_category");
		$this->title_content = htmlspecialchars_decode($this->group_info["mysql_fetch_array"]->group_name);
		$this->template->content=new View("/template/template3");
	}
	
	//search groups
	public function commonsearch() 
	{   
		$key=html::specialchars($this->input->get("search_value"));
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='commonsearch')
		$page_no = 1;
		$offset=15*($page_no-1);

		$this->get_groups_list=$this->model->get_search_groups_list($key,$offset,15);

		$this->total=$this->model->get_search_groups_count($key);
	
		$this->template->pagination = new Pagination(array
		 (
		 'base_url'       => 'groups',
		 'uri_segment'    =>'commonsearch',
		 'items_per_page' => 15,
		 'total_items'    => $this->total,
		 'style'         => 'classic' )
		 );

		//template code
		$this->template->title="Search Groups";
		$this->left=new View("groups_leftmenu");
		$this->right=new View("groups_content");
		$this->title_content = "Search Groups";
		$this->template->content=new View("/template/template2");
	}

} // End Welcome Controller
