<?php defined('SYSPATH') OR die('No direct access allowed.'); 
class Nauth_Core {
	
	public function __construct()
	{
		parent::__construct();
		include Kohana::find_file('../application/config','database',TRUE,'php'); 
		$this->docroot =  Kohana::config('database.server_path');
		
		$this->users=new Users_Model();
	}
	
	
	 //checking login 
	public function module_login($module = "")
	{
		$session = Session::instance();
		if(!$session->get('userid')){
			if(in_array($module,$this->login_moule)){
				return;
			}
			else{
				Nauth::setMessage(-1,"Please Login To Proceed Further");
				$session->set("reffer_url" , substr($_SERVER['REQUEST_URI'],1));
				url::redirect($this->docroot);
			}
		}
		return;
	}
    //checking login 
	public function is_login($url = "")
	{
		$session = Session::instance();
		if(!$session->get('userid')){
			Nauth::setMessage(-1,"Please Login To Proceed Further");
			url::redirect($this->docroot."users/login");
		}
		return;
	}
	
	public function thirdpartylogin($userid='',$username='',$usertype='')
	{
		if($userid && $username && $usertype){
			$session = Session::instance();
			$session->set('userid',$userid);
			$session->set('username',$username);
			$session->set('usertype',$usertype);
			return TRUE; 
		}else{
			return FALSE;
		}
	}
	
	public function setpermission($add='',$edit='',$delete='')
	{
		$this->ADD = $this->EDIT = $this->DELETE = FALSE ;
		if($add){
			$this->ADD = TRUE;
		}
		if($edit){
			$this->EDIT = TRUE;
		}
		if($delete){
			$this->DELETE = TRUE;
		}
		return $this;
	}

	//set the session
	public function setMessage($type='',$msg='')
	{
		
		$session = Session::instance();
		if($type=='1'){
			$session->set('Msg',$msg);
		}elseif($type=='-1')
		{
			$session->set('Emsg',$msg);
		}
	}
	public function print_name($id,$name)
	{
	
		if($this->userid){
			$url = $this->docroot."profile/view/?uid=".$id;
		}
		else{
			$url =  $this->docroot."professional/".$name."_".$id.".html"; 
		}
		?>
			<a href="<?php echo $url; ?>" title="<?php echo $name;?>"><strong>
			<?php echo ucfirst($name);?></strong></a>
		<?php 
	}
	
 	//GET USER IMAGE 40x40
			
	public function getPhoto($id='',$name='',$photo='')
	{
		$img = "public/user_photo/50/".$id.".jpg";
		if(file_exists($img)){
			$img_path = $this->docroot.$img;
		}
		else{
			$img_url = "http://www.gravatar.com/avatar/".md5($id.$name)."?s=40&amp;d=wavatar"; 
			$img_path = $img_url;
		}  
		
		if($this->userid){
			$url = $this->docroot."profile/view/?uid=".$id;
		}
		else{
			$url =  $this->docroot."professional/".$name."_".$id.".html"; 
		}
		
		
		?>
        	<a href="<?php echo $url; ?>" class="less_link">
   				 <img src="<?php echo $img_path; ?>" title="<?php echo ucfirst($name);?>" alt="<?php echo $name;?>" width="40" height="40" class="upd_photo" border="0" />  
    		</a>  
       <?php
	}   
	 
	 public function getPhotoTarget($id='',$name='',$photo='')
	{
		
		$img = "public/user_photo/50/".$id.".jpg";
		if(file_exists($img)){
			$img_path = $this->docroot.$img;
		}
		else{
			$img_url = "http://www.gravatar.com/avatar/".md5($id.$name)."?d=wavatar&s=40"; 
			$img_path = $img_url;
		} 
		
		
		if($this->userid){
			$url = $this->docroot."profile/view/?uid=".$id;
		}
		else{
			$url =  $this->docroot."professional/".$name."_".$id.".html"; 
		} 
		?>
        	<a href="<?php echo $url; ?>" target="_blank" class="less_link">
   				 <img src="<?php echo $img_path; ?>" target="_blank" title="<?php echo ucfirst($name);?>" alt="<?php echo $name;?>" class="upd_photo" border="0" />  
    		</a>  <br/>
            <a class="less_link" href="<?php echo $this->docroot;?>profile/view/?uid=<?php echo $id ;?>" target="_blank" title="<?php echo $name; ?>">
            <?php echo wordwrap($name, 8, "<br/>", true);  ?>
            </a>
       <?php
	}   
	      
	//GET USER IMAGE, NAME 40x40
	
	public function getPhotoName($id='',$name='',$photo='', $isFB = 0, $isTwitter =0)
	{
		$img = "public/user_photo/50/".$id.".jpg";
		if(file_exists($img)){
			$img_path = $this->docroot.$img;
		}
		else{
			$img_url = "http://www.gravatar.com/avatar/".md5($id.$name)."?d=wavatar&s=40"; 
			$img_path = $img_url;
		}  
		
		if($this->userid){
			$url = $this->docroot."profile/view/?uid=".$id;
		}
		else{
			$url =  $this->docroot."professional/".$name."_".$id.".html"; 
		} 
		?>
        	<a href="<?php echo $url; ?>" class="less_link">
   				 <img src="<?php echo $img_path; ?>" title="<?php echo ucfirst($name);?>" alt="<?php echo $name;?>" class="upd_photo" border="0" />  
    		</a>  
		<br/> 
            <a class="less_link" href="<?php echo $url; ?>" title="<?php echo $name; ?>">
            <?php if(strlen($name)>8) { echo substr($name,0,6)."."; } else { echo $name; }  ?>
            </a>
	<?php
	}
	
	//get user small image and name with single parameter "id"

	public function getNameImage($user_id='',$name='')
	{ 
		$img = "public/user_photo/50/".$user_id.".jpg";
		if(file_exists($img)){
			$img_path = $this->docroot.$img;
		}
		else{
			$img_url = "http://www.gravatar.com/avatar/".md5($user_id.$name)."?d=wavatar&s=40"; 
			$img_path = $img_url;
		}  
		if($this->userid){
			$url = $this->docroot."profile/view/?uid=".$user_id;
		}
		else{
			$url =  $this->docroot."professional/".$name."_".$user_id.".html"; 
		} 
		?>
        	<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $user_id ;?>" class="less_link">
   		<img src="<?php echo $img_path; ?>" title="<?php echo ucfirst($name);?>" alt="<?php echo $name;?>" class="upd_photo" border="0" />  
    		</a>  
     
    	<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $user_id; ?>" title="<?php echo $name; ?>" class="less_link">
	<?php  if(strlen($name)>8) {  echo substr(ucfirst($name),0,5)."..."; } else { echo ucfirst($name); } ?>
  	  </a>
	<?php 
	}	
        //get name alone with single parameter "id"

        public function get_Name($user_id='')
	{
	        $this->users=new Users_Model();
	        $this->Name_Image=$this->users->nameimage($user_id);  
	        if(count($this->Name_Image) > 0)
	        {
	        ?>
            	<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php if($this->Name_Image){ echo $this->Name_Image['mysql_fetch_row']->id; } else{} ?>" title="<?php if($this->Name_Image){ echo $this->Name_Image['mysql_fetch_row']->name; } else{} ?>" class="less_link">
	        <strong><?php if($this->Name_Image) { echo  ucfirst($this->Name_Image["mysql_fetch_row"]->name);  } else{} ?></strong>
          	  </a>
	        <?php 
	        }
	}
	/*
	//send the mail
	public function send_mail($to='',$from='',$subject='',$message='',$type='',$objecttype = '')
	{
		
	
		if(!empty($type))
		{
			$this->users=new Users_Model();
			$this->mail_template=$this->users->get_mail_template($type);
			$message=htmlspecialchars_decode($this->mail_template["mysql_fetch_array"]->mail_temp_code);
		}
		
		// To send HTML mail, the Content-type header must be set
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		
		// Additional headers
		$headers .= 'From:'.$from.'' . "\r\n";
		$headers .= 'Cc: '.$from.'' . "\r\n";
		$headers .= 'Bcc: '.$from.'' . "\r\n";

		mail($to, $subject,$message, $headers);
		
	}
*/
	public function send_mail_id($user_id = "", $friend_id = "", $type = "", $description = "", $objecttype = "")
	{
                
		if(!empty($type))
		{
			$this->users=new Users_Model();
                        $current_user = $this->session->get('username');
                        $this->mail_template = $this->users->get_mail_template($type);
                        if(count($this->mail_template)>0)
                        {
			$subject = htmlspecialchars_decode($this->mail_template["mysql_fetch_array"]->mail_subject);		       
                        }
                        else
                        {
                        $subject = $type;
                        }
			$this->to_mail_id = $this->users->get_mail_addr($user_id);
			
			if(count($this->to_mail_id) > 0){
			
				$to = htmlspecialchars_decode($this->to_mail_id["mysql_fetch_array"]->email);
				
				$user_name = $this->to_mail_id["mysql_fetch_array"]->name;
		      
				$this->from_mail_id = $this->users->get_admin_mail_addr();
				if(count($this->from_mail_id))
				{
					$from = htmlspecialchars_decode($this->from_mail_id["mysql_fetch_array"]->email);
				}
				else
				{
					$from  = "admin"; //#A873C5
				}
	
	                        if($current_user)
	                        {
        	                        $sub_message = ucfirst($current_user).' '.$subject.' @ <a href="'.$this->docroot.'" target="_blank" title="'.$this->docroot.'" style="text-decoration:none;">'.$this->docroot.'.</a> <br>';
	                        }
	                        else
	                        {
	                                $sub_message = $subject.' at '.$this->docroot.' <br>';
	                        }
					$message = '<div style="border:1px solid #1A4680; width:650px;float:left;">
                                        <div style="width:648px; margin:auto; background:#1A4680; height:100px;margin-top:1px;">
                                        <a href="'.$this->docroot.'" target="_blank" title="'.$this->docroot.'" style="text-decoration:none;">
                                        <img src="'.$this->docroot.'public/themes/default/images/logo.jpg" title="'.$this->docroot.'" style="margin:13px 0px 0px 15px;border:0px;" /> <br>
                                        </a>
                                        </div>
                                        <div style="color:#000; font-family:Arial, Helvetica, sans-serif; font-size:12px; margin:10px;">
                                        <p style="font-size:16px; margin-left:20px;"><strong>Dear '.ucfirst($user_name).',</strong></p>
                                        <p style="margin-left:40px; line-height:20px; margin-bottom:10px;">'.$sub_message.$description.'</p>
                                        <p style="margin-left:20px; margin-top:20px;font-size:14px;"><strong>Thanks,</strong><div style="margin-left:20px;">Ndot SAndwich Team. <br>
                                        </div></p>
                                        </div>
                                        </div>';	
                                        
                                        $from = "ashokkumar@ndot.in";
					// To send HTML mail, the Content-type header must be set
					$headers  = 'MIME-Version: 1.0' . "\r\n";
					$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
			
					// Additional headers
					$headers .= 'From:'.$this->session->get('email').'' . "\r\n";
					$headers .= 'Cc: '.$from.'' . "\r\n";
				   
					
					//common::insert_mail($user_id,$friend_id,$subject,$message,$objecttype);	
					@mail($to,$subject,$message, $headers);
		   	} 
		}
		return 1;
	}

        //Function to check module is enable or not
	public function mod_status($mod_name){
	}

        //ping the urls to make index
        public function ping($title, $title_url) 
        {
               
                if($_SERVER['HTTP_HOST']!= '192.168.1.2:5066')
                {
                /*
                include Kohana::find_file('../application/config','database',TRUE,'php'); 
				$this->docroot =  Kohana::config('database.server_path');
		
                $url = $this->docroot.$title_url;
                set_time_limit(0);
                $message = '<?xml version="1.0"?>' . "\r\n";
                $message = $message . "<methodCall>\r\n";
                $message = $message . " <methodName>weblogUpdates.ping</methodName>\r\n";
                $message = $message . " <params>\r\n";
                $message = $message . "  <param>\r\n";
                $message = $message . "   <value>$title</value>\r\n";
                $message = $message . "  </param>\r\n";
                $message = $message . "  <param>\r\n";
                $message = $message . "   <value>$url</value>\r\n";
                $message = $message . "  </param>\r\n";
                $message = $message . " </params>\r\n";
                $message = $message . "</methodCall>";

                //Add your RPC PING URIs here:
				
                $urls = array(
                'http://api.my.yahoo.com/RPC2',
                'http://blogsearch.google.com/ping/RPC2'
                );
                
                // DO NOT TOUCH THIS SHIT UNLESS YOU KNOW WHAT YOU'RE DOING---------------
                        foreach($urls as $i => $url) 
                        {
                                $c = curl_init();
                                curl_setopt($c, CURLOPT_URL, $url);
                                curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
                                curl_setopt($c, CURLOPT_FOLLOWLOCATION, 1);
                                curl_setopt($c, CURLOPT_POST, TRUE);
                                curl_setopt($c, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)");
                                curl_setopt($c, CURLOPT_POSTFIELDS, $message);
                                $content = trim(curl_exec($c));
                               
                                curl_close($c);
                        } 
				return;
		*/
	        }
        }


}
?>
